import javax.vecmath.Color3f;


public class Arrete {
	public Couleur couleur;
	public Arrete arreteAdj;
	public Color3f jaune;
	public Color3f blanc;
	public Color3f orange;
	public Color3f rouge;
	public Color3f vert;
	public Color3f bleu;
	
	public Arrete clone(){  
		Arrete ar = new Arrete(couleur);
		return ar;
    }
	

	public Arrete(Couleur couleurArrete){
		couleur = couleurArrete;
		jaune = new Color3f(1f,1f,0f);
		blanc = new Color3f(1f,1f,1f);
		rouge = new Color3f(1f,0f,0f);
		orange = new Color3f(1f,0.5f,0f);
		vert = new Color3f(0f,1f,0f);
		bleu = new Color3f(0f,0f,1f);
			}
			
	public Color3f color()
		{
			Color3f res = jaune;
			switch (couleur)
				{
					case Orange : res = orange;
							break;
					case Blanc : res =blanc;
							break;
					case Bleu : res = bleu;
							break;
					case Vert : res = vert;
							break;
					case Rouge : res =rouge;
							break;
				};
			return res;
		}
			
	public void afficher() {
		switch (couleur)
				{
					case Orange : System.out.print("O ");
							break;
					case Blanc : System.out.print("Bc");
							break;
					case Bleu : System.out.print("Bl");
							break;
					case Vert : System.out.print("V ");
							break;
					case Rouge : System.out.print("R ");
							break;
					case Jaune : System.out.print("J ");
							break;
				};
			}
  }
