//Java standart API
import java.awt.Frame;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.BorderLayout;
//Java3d API
import com.sun.j3d.utils.universe.SimpleUniverse;
import javax.media.j3d.Canvas3D;
import javax.media.j3d.BranchGroup;
import javax.media.j3d.TransformGroup;
import javax.media.j3d.Transform3D;
import javax.vecmath.Vector3f;
import javax.vecmath.Color3f;
//mes objets

import javax.media.j3d.BoundingSphere;
import javax.vecmath.Point3d;


public class CubeBox extends BranchGroup
	{
	Rubik rubik;
	public CubeBox(Rubik rubik)
		{
			this.rubik=rubik;
		}
	public BranchGroup creerCube()
		{

			BranchGroup cube =new BranchGroup();
			cube.setCapability(BranchGroup.ALLOW_DETACH);
			facette ff1=new facette(new Vector3f(0f,0f,0.6f),rubik.orange.color());
			facette ff2=new facette(new Vector3f(0f,-0.4f,0.6f),rubik.orange.arrete3.color());
			facette ff3=new facette(new Vector3f(0f,0.4f,0.6f),rubik.orange.arrete1.color());
			facette ff4=new facette(new Vector3f(0.4f,0f,0.6f),rubik.orange.arrete2.color());
			facette ff5=new facette(new Vector3f(-0.4f,0f,0.6f),rubik.orange.arrete4.color());
			facette ff6=new facette(new Vector3f(0.4f,-0.4f,0.6f),rubik.orange.coin3.color());
			facette ff7=new facette(new Vector3f(0.4f,0.4f,0.6f),rubik.orange.coin2.color());
			facette ff8=new facette(new Vector3f(-0.4f,0.4f,0.6f),rubik.orange.coin1.color());
			facette ff9=new facette(new Vector3f(-0.4f,-0.4f,0.6f),rubik.orange.coin4.color());
			
			cube.addChild(ff1.createFace("F"));
			cube.addChild(ff2.createFace("F"));
			cube.addChild(ff3.createFace("F"));
			cube.addChild(ff4.createFace("F"));
			cube.addChild(ff5.createFace("F"));
			cube.addChild(ff6.createFace("F"));
			cube.addChild(ff7.createFace("F"));
			cube.addChild(ff8.createFace("F"));
			cube.addChild(ff9.createFace("F"));
			
			
			
			facette fl1=new facette(new Vector3f(-0.6f,0f,0f),rubik.vert.color());
			facette fl2=new facette(new Vector3f(-0.6f,-0.4f,0f),rubik.vert.arrete2.color());
			facette fl3=new facette(new Vector3f(-0.6f,0.4f,0f),rubik.vert.arrete4.color());
			facette fl4=new facette(new Vector3f(-0.6f,0f,-0.4f),rubik.vert.arrete3.color());
			facette fl5=new facette(new Vector3f(-0.6f,0f,0.4f),rubik.vert.arrete1.color());
			facette fl6=new facette(new Vector3f(-0.6f,0.4f,0.4f),rubik.vert.coin1.color());
			facette fl7=new facette(new Vector3f(-0.6f,-0.4f,0.4f),rubik.vert.coin2.color());
			facette fl8=new facette(new Vector3f(-0.6f,-0.4f,-0.4f),rubik.vert.coin3.color());
			facette fl9=new facette(new Vector3f(-0.6f,0.4f,-0.4f),rubik.vert.coin4.color());
			
			cube.addChild(fl1.createFace("L"));
			cube.addChild(fl2.createFace("L"));
			cube.addChild(fl3.createFace("L"));
			cube.addChild(fl4.createFace("L"));
			cube.addChild(fl5.createFace("L"));
			cube.addChild(fl6.createFace("L"));
			cube.addChild(fl7.createFace("L"));
			cube.addChild(fl8.createFace("L"));
			cube.addChild(fl9.createFace("L"));
			
			facette fu1=new facette(new Vector3f(0f,0.6f,0f),rubik.jaune.color());
			facette fu2=new facette(new Vector3f(-0.4f,0.6f,0f),rubik.jaune.arrete2.color());
			facette fu3=new facette(new Vector3f(0.4f,0.6f,0f),rubik.jaune.arrete4.color());
			facette fu4=new facette(new Vector3f(0f,0.6f,-0.4f),rubik.jaune.arrete3.color());
			facette fu5=new facette(new Vector3f(0f,0.6f,0.4f),rubik.jaune.arrete1.color());
			facette fu6=new facette(new Vector3f(0.4f,0.6f,-0.4f),rubik.jaune.coin4.color());
			facette fu7=new facette(new Vector3f(-0.4f,0.6f,-0.4f),rubik.jaune.coin3.color());
			facette fu8=new facette(new Vector3f(-0.4f,0.6f,0.4f),rubik.jaune.coin2.color());
			facette fu9=new facette(new Vector3f(0.4f,0.6f,0.4f),rubik.jaune.coin1.color());
			
			cube.addChild(fu1.createFace("U"));
			cube.addChild(fu2.createFace("U"));
			cube.addChild(fu3.createFace("U"));
			cube.addChild(fu4.createFace("U"));
			cube.addChild(fu5.createFace("U"));
			cube.addChild(fu6.createFace("U"));
			cube.addChild(fu7.createFace("U"));
			cube.addChild(fu8.createFace("U"));
			cube.addChild(fu9.createFace("U"));
			
			
			facette fd1=new facette(new Vector3f(0f,-0.6f,0f),rubik.blanc.color());
			facette fd2=new facette(new Vector3f(-0.4f,-0.6f,0f),rubik.blanc.arrete4.color());
			facette fd3=new facette(new Vector3f(0.4f,-0.6f,0f),rubik.blanc.arrete2.color());
			facette fd4=new facette(new Vector3f(0f,-0.6f,-0.4f),rubik.blanc.arrete3.color());
			facette fd5=new facette(new Vector3f(0f,-0.6f,0.4f),rubik.blanc.arrete1.color());
			facette fd6=new facette(new Vector3f(0.4f,-0.6f,-0.4f),rubik.blanc.coin3.color());
			facette fd7=new facette(new Vector3f(-0.4f,-0.6f,-0.4f),rubik.blanc.coin4.color());
			facette fd8=new facette(new Vector3f(-0.4f,-0.6f,0.4f),rubik.blanc.coin1.color());
			facette fd9=new facette(new Vector3f(0.4f,-0.6f,0.4f),rubik.blanc.coin2.color());
			
			cube.addChild(fd1.createFace("D"));
			cube.addChild(fd2.createFace("D"));
			cube.addChild(fd3.createFace("D"));
			cube.addChild(fd4.createFace("D"));
			cube.addChild(fd5.createFace("D"));
			cube.addChild(fd6.createFace("D"));
			cube.addChild(fd7.createFace("D"));
			cube.addChild(fd8.createFace("D"));
			cube.addChild(fd9.createFace("D"));
			
			
			facette fr1=new facette(new Vector3f(0.6f,0f,0f),rubik.bleu.color());
			facette fr2=new facette(new Vector3f(0.6f,-0.4f,0f),rubik.bleu.arrete4.color());
			facette fr3=new facette(new Vector3f(0.6f,0.4f,0f),rubik.bleu.arrete2.color());
			facette fr4=new facette(new Vector3f(0.6f,0f,-0.4f),rubik.bleu.arrete3.color());
			facette fr5=new facette(new Vector3f(0.6f,0f,0.4f),rubik.bleu.arrete1.color());
			facette fr6=new facette(new Vector3f(0.6f,0.4f,0.4f),rubik.bleu.coin2.color());
			facette fr7=new facette(new Vector3f(0.6f,-0.4f,0.4f),rubik.bleu.coin1.color());
			facette fr8=new facette(new Vector3f(0.6f,-0.4f,-0.4f),rubik.bleu.coin4.color());
			facette fr9=new facette(new Vector3f(0.6f,0.4f,-0.4f),rubik.bleu.coin3.color());
			
			cube.addChild(fr1.createFace("R"));
			cube.addChild(fr2.createFace("R"));
			cube.addChild(fr3.createFace("R"));
			cube.addChild(fr4.createFace("R"));
			cube.addChild(fr5.createFace("R"));
			cube.addChild(fr6.createFace("R"));
			cube.addChild(fr7.createFace("R"));
			cube.addChild(fr8.createFace("R"));
			cube.addChild(fr9.createFace("R"));
			
			facette fb1=new facette(new Vector3f(0f,0f,-0.6f),rubik.rouge.color());
			facette fb2=new facette(new Vector3f(0f,-0.4f,-0.6f),rubik.rouge.arrete1.color());
			facette fb3=new facette(new Vector3f(0f,0.4f,-0.6f),rubik.rouge.arrete3.color());
			facette fb4=new facette(new Vector3f(0.4f,0f,-0.6f),rubik.rouge.arrete2.color());
			facette fb5=new facette(new Vector3f(-0.4f,0f,-0.6f),rubik.rouge.arrete4.color());
			facette fb6=new facette(new Vector3f(0.4f,-0.4f,-0.6f),rubik.rouge.coin2.color());
			facette fb7=new facette(new Vector3f(0.4f,0.4f,-0.6f),rubik.rouge.coin3.color());
			facette fb8=new facette(new Vector3f(-0.4f,0.4f,-0.6f),rubik.rouge.coin4.color());
			facette fb9=new facette(new Vector3f(-0.4f,-0.4f,-0.6f),rubik.rouge.coin1.color());
			
			cube.addChild(fb1.createFace("B"));
			cube.addChild(fb2.createFace("B"));
			cube.addChild(fb3.createFace("B"));
			cube.addChild(fb4.createFace("B"));
			cube.addChild(fb5.createFace("B"));
			cube.addChild(fb6.createFace("B"));
			cube.addChild(fb7.createFace("B"));
			cube.addChild(fb8.createFace("B"));
			cube.addChild(fb9.createFace("B"));

			
			return cube;
			
				
		}
	
	}