import java.util.ArrayList;

enum Couleur {Rouge, Bleu, Jaune, Vert , Blanc, Orange};

public class Ia {
	public Rubik rubik;
	public Croix_blanche croix_blanche;
	public Face_blanche  face_blanche;
	public Couronne couronne;
	public Croix_jaune croix_jaune;
	public Orientation orientation;
	public Place_Coin place_Coin;
	public Final finale;
	
//////////////////////////////////////////////////////////////////////////////////////	
//			Patron de Rubik's cube referent 			    //
//////////////////////////////////////////////////////////////////////////////////////
// 										    //
//  		            1 | 1  | 2						    //
// 		            4 | o  | 2						    //
// 		            4 | 3  | 3						    //
//		1 | 1 | 2 | 1 | 1  | 2 | 1 | 1  | 2 | 1 | 1 | 2 		    //
// 		4 | v | 2 | 4 | bc | 2 | 4 | bl | 2 | 4 | j | 2  		    //
// 		4 | 3 | 3 | 4 | 3  | 3 | 4 | 3  | 3 | 4 | 3 | 3 		    //
//   		            1 | 1  | 2 						    //
//     		            4 | r  | 2 						    //
//     		            4 | 3  | 3 						    //
// 										    //		
//////////////////////////////////////////////////////////////////////////////////////

	public Ia() {
		rubik = new Rubik();
		croix_blanche = new Croix_blanche();
		face_blanche  = new Face_blanche();
		couronne = new Couronne();
		croix_jaune = new Croix_jaune();
		orientation = new Orientation();
		place_Coin = new Place_Coin();
		finale = new Final();
	}
	
	public Ia(Rubik rubik)
		{
		this.rubik = rubik.clone();
		croix_blanche = new Croix_blanche();
		face_blanche  = new Face_blanche();
		couronne = new Couronne();
		croix_jaune = new Croix_jaune();
		orientation = new Orientation();
		place_Coin = new Place_Coin();
		finale = new Final();
		}

	public void croix_blanche() {
		
		//////////////////////////////////////////////////
		//		Face	 Orange			//
		//////////////////////////////////////////////////
		if (rubik.orange.arrete1.couleur == Couleur.Blanc)
			{
			switch (rubik.orange.arrete1.arreteAdj.couleur)
					{
					case Orange   : rubik.rotationHoraire(Couleur.Orange);
							rubik.rotationHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Bleu);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							croix_blanche.orange = true; 
							break;//check

					case Rouge    : rubik.rotationHoraire(Couleur.Jaune);
							rubik.rotationHoraire(Couleur.Jaune);
							rubik.rotationHoraire(Couleur.Rouge);
							rubik.rotationHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Vert);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							croix_blanche.rouge = true; 
							break;//check
							
					case Bleu     : rubik.rotationAntiHoraire(Couleur.Jaune);
							rubik.rotationAntiHoraire(Couleur.Bleu);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationHoraire(Couleur.Orange);
							rubik.rotationHoraire(Couleur.Blanc);
							croix_blanche.bleu = true;
							break;//check

					case Vert     : rubik.rotationHoraire(Couleur.Jaune);
							rubik.rotationHoraire(Couleur.Vert);
							rubik.rotationHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Orange);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							croix_blanche.vert = true; 
							break;//check
					};
			}

		if (rubik.orange.arrete2.couleur == Couleur.Blanc)
			{
			switch (rubik.orange.arrete2.arreteAdj.couleur)
					{
					case Orange   : rubik.rotationHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Bleu);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							croix_blanche.orange = true;
							break;//check

					case Rouge    : rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Bleu);
							rubik.rotationHoraire(Couleur.Blanc);
							croix_blanche.rouge = true;
							break;//check
								
					case Bleu     : rubik.rotationAntiHoraire(Couleur.Bleu);
							croix_blanche.bleu = true;
							break;//check

					case Vert     : rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Bleu);
							rubik.rotationHoraire(Couleur.Blanc);
							rubik.rotationHoraire(Couleur.Blanc);
							croix_blanche.vert = true;
							break;//check
					};
			
			} 
		
		if (rubik.orange.arrete3.couleur == Couleur.Blanc)
			{
				rubik.rotationHoraire(Couleur.Orange);
			} 

		if (rubik.orange.arrete4.couleur == Couleur.Blanc)
			{
			switch (rubik.orange.arrete4.arreteAdj.couleur)
					{
					case Orange   : rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationHoraire(Couleur.Vert);
							rubik.rotationHoraire(Couleur.Blanc);
							croix_blanche.orange = true;
							break;//check

					case Rouge    : rubik.rotationHoraire(Couleur.Blanc);
							rubik.rotationHoraire(Couleur.Vert);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							croix_blanche.rouge = true;
							break;//check
								
					case Bleu     : rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationHoraire(Couleur.Vert);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							croix_blanche.bleu = true;
							break;//check

					case Vert     : rubik.rotationHoraire(Couleur.Vert);
							croix_blanche.vert = true;
							break;//check
					};
			}


		//////////////////////////////////////////////////
		//		Face	 Vert  			//
		//////////////////////////////////////////////////
		
		if (rubik.vert.arrete4.couleur == Couleur.Blanc)
			{
				rubik.rotationAntiHoraire(Couleur.Jaune);
			}

		if (rubik.vert.arrete1.couleur == Couleur.Blanc)
			{
			switch (rubik.vert.arrete1.arreteAdj.couleur)
					{
					case Orange   : rubik.rotationAntiHoraire(Couleur.Orange);
							croix_blanche.orange = true;
							break;//check

					case Rouge    : rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Orange);
							rubik.rotationHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							croix_blanche.rouge = true;
							break;//check
								
					case Bleu     : rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Orange);
							rubik.rotationHoraire(Couleur.Blanc);
							croix_blanche.bleu = true;//check
							break;

					case Vert     : rubik.rotationHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Orange);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							croix_blanche.vert = true;
							break;//check
					};
			
			} 
		
		if (rubik.vert.arrete2.couleur == Couleur.Blanc)
			{
				rubik.rotationHoraire(Couleur.Vert);
			} 

		if (rubik.vert.arrete3.couleur == Couleur.Blanc)
			{
			switch (rubik.vert.arrete3.arreteAdj.couleur)
					{
					case Orange   : rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationHoraire(Couleur.Rouge);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							croix_blanche.orange = true;
							break;//check

					case Rouge    : rubik.rotationHoraire(Couleur.Rouge);
							croix_blanche.rouge = true;
							break;//check
								
					case Bleu     : rubik.rotationHoraire(Couleur.Blanc);
							rubik.rotationHoraire(Couleur.Rouge);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							croix_blanche.bleu = true;
							break;//check

					case Vert     : rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationHoraire(Couleur.Rouge);
							rubik.rotationHoraire(Couleur.Blanc);
							croix_blanche.vert = true;
							break;//check
					};
			}

		//////////////////////////////////////////////////
		//		Face	 Bleu			//
		//////////////////////////////////////////////////

		if (rubik.bleu.arrete1.couleur == Couleur.Blanc)
			{
			switch (rubik.bleu.arrete1.arreteAdj.couleur)
					{
					case Orange   : rubik.rotationHoraire(Couleur.Orange);
							croix_blanche.orange = true;
							break;//check

					case Rouge    : rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationHoraire(Couleur.Orange);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							croix_blanche.rouge = true;
							break;//check
								
					case Bleu     : rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationHoraire(Couleur.Orange);
							rubik.rotationHoraire(Couleur.Blanc);
							croix_blanche.bleu = true;
							break;//check
	
					case Vert     : rubik.rotationHoraire(Couleur.Blanc);
							rubik.rotationHoraire(Couleur.Orange);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							croix_blanche.vert = true;
							break;//check
					};
			}

		if (rubik.bleu.arrete2.couleur == Couleur.Blanc)
			{
				rubik.rotationHoraire(Couleur.Jaune);
			} 
		
		if (rubik.bleu.arrete4.couleur == Couleur.Blanc)
			{
				rubik.rotationHoraire(Couleur.Bleu);
			} 

		if (rubik.bleu.arrete3.couleur == Couleur.Blanc)
			{
			switch (rubik.bleu.arrete3.arreteAdj.couleur)
					{
					case Orange   : rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Rouge);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							croix_blanche.orange = true;
							break;//check

					case Rouge    : rubik.rotationAntiHoraire(Couleur.Rouge);
							croix_blanche.rouge = true;
							break;
								
					case Bleu     : rubik.rotationHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Rouge);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							croix_blanche.bleu = true;
							break;

					case Vert     : rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Rouge);
							rubik.rotationHoraire(Couleur.Blanc);
							croix_blanche.vert = true;
							break;
					};
			}
			

		//////////////////////////////////////////////////
		//		Face	 Rouge			//
		//////////////////////////////////////////////////

		if (rubik.rouge.arrete2.couleur == Couleur.Blanc)
			{
			switch (rubik.rouge.arrete2.arreteAdj.couleur)
					{
					case Orange   : rubik.rotationHoraire(Couleur.Blanc);
							rubik.rotationHoraire(Couleur.Bleu);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							croix_blanche.orange = true;//check
							break;

					case Rouge    : rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationHoraire(Couleur.Bleu);
							rubik.rotationHoraire(Couleur.Blanc);
							croix_blanche.rouge = true;//check
							break;
								
					case Bleu     : rubik.rotationHoraire(Couleur.Bleu);
							croix_blanche.bleu = true;
							break;
	
					case Vert     : rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationHoraire(Couleur.Bleu);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							croix_blanche.vert = true;
							break;
					};
			}

		if (rubik.rouge.arrete3.couleur == Couleur.Blanc)//on ramene au cas du Orange
			{
				rubik.rotationHoraire(Couleur.Jaune);
				rubik.rotationHoraire(Couleur.Jaune);
			} 
		
		if (rubik.rouge.arrete1.couleur == Couleur.Blanc)
			{
				rubik.rotationHoraire(Couleur.Rouge);
			} 

		if (rubik.rouge.arrete4.couleur == Couleur.Blanc)
			{
			switch (rubik.rouge.arrete4.arreteAdj.couleur)
					{
					case Orange   : rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Vert);
							rubik.rotationHoraire(Couleur.Blanc);
							croix_blanche.orange = true;
							break;

					case Rouge    : rubik.rotationHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Vert);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							croix_blanche.rouge = true;
							break;
								
					case Bleu     : rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Vert);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							rubik.rotationAntiHoraire(Couleur.Blanc);
							croix_blanche.bleu = true;
							break;

					case Vert     : rubik.rotationAntiHoraire(Couleur.Vert);
							croix_blanche.vert = true;
							break;
					};
			}



		
		

		//////////////////////////////////////////////////
		//		Face	 Jaune			//
		//////////////////////////////////////////////////

		if (rubik.jaune.arrete1.couleur == Couleur.Blanc)
			{
			switch (rubik.jaune.arrete1.arreteAdj.couleur)
					{
					case Orange   : rubik.rotationHoraire(Couleur.Orange);
							rubik.rotationHoraire(Couleur.Orange);
							croix_blanche.orange = true; 
							break;

					case Rouge    : rubik.rotationHoraire(Couleur.Jaune);
							rubik.rotationHoraire(Couleur.Jaune);
							break;
								
					case Bleu     : rubik.rotationAntiHoraire(Couleur.Jaune);
							break;

					case Vert     : rubik.rotationHoraire(Couleur.Jaune);
							break;
					};
			}

		if (rubik.jaune.arrete2.couleur == Couleur.Blanc)
			{
			switch (rubik.jaune.arrete2.arreteAdj.couleur)
					{
					case Orange   : rubik.rotationAntiHoraire(Couleur.Jaune);
							break;

					case Rouge    : rubik.rotationHoraire(Couleur.Jaune);
							break;
								
					case Bleu     : rubik.rotationHoraire(Couleur.Jaune);
							rubik.rotationHoraire(Couleur.Jaune);
							break;

					case Vert     : rubik.rotationHoraire(Couleur.Vert);
							rubik.rotationHoraire(Couleur.Vert);
							croix_blanche.vert = true;
							break;
					};
			
			} 
		
		if (rubik.jaune.arrete3.couleur == Couleur.Blanc)
			{
			switch (rubik.jaune.arrete3.arreteAdj.couleur)
					{
					case Orange   : rubik.rotationHoraire(Couleur.Jaune);
							rubik.rotationHoraire(Couleur.Jaune);
							break;

					case Rouge    : rubik.rotationHoraire(Couleur.Rouge);
							rubik.rotationHoraire(Couleur.Rouge);
							croix_blanche.rouge = true;
							break;
								
					case Bleu     : rubik.rotationHoraire(Couleur.Jaune);
							break;

					case Vert     : rubik.rotationAntiHoraire(Couleur.Jaune);
							break;
					};
			} 

		if (rubik.jaune.arrete4.couleur == Couleur.Blanc)
			{
			switch (rubik.jaune.arrete4.arreteAdj.couleur)
					{
					case Orange   : rubik.rotationHoraire(Couleur.Jaune);
							break;

					case Rouge    : rubik.rotationAntiHoraire(Couleur.Jaune);
							break;
								
					case Bleu     : rubik.rotationHoraire(Couleur.Bleu);
							rubik.rotationHoraire(Couleur.Bleu);
							croix_blanche.bleu = true;
							break;

					case Vert     : rubik.rotationHoraire(Couleur.Jaune);
						rubik.rotationHoraire(Couleur.Jaune);
							break;
					};
			}


		//////////////////////////////////////////////////
		//		Face	 Blanc			//
		//////////////////////////////////////////////////

		if (rubik.blanc.arrete1.couleur == Couleur.Blanc && rubik.blanc.arrete1.arreteAdj.couleur == Couleur.Orange)
			{croix_blanche.orange = true;} else {rubik.rotationHoraire(Couleur.Orange); croix_blanche.orange = false;}

		if (rubik.blanc.arrete2.couleur == Couleur.Blanc && rubik.blanc.arrete2.arreteAdj.couleur == Couleur.Bleu)
			{croix_blanche.bleu = true;} else {rubik.rotationHoraire(Couleur.Bleu); croix_blanche.bleu = false;}

		if (rubik.blanc.arrete3.couleur == Couleur.Blanc && rubik.blanc.arrete3.arreteAdj.couleur == Couleur.Rouge)
			{croix_blanche.rouge = true;} else {rubik.rotationHoraire(Couleur.Rouge); croix_blanche.rouge = false;}
		
		if (rubik.blanc.arrete4.couleur == Couleur.Blanc && rubik.blanc.arrete4.arreteAdj.couleur == Couleur.Vert)
			{croix_blanche.vert = true;} else {rubik.rotationHoraire(Couleur.Vert); croix_blanche.vert = false;}

		}
		





	public void face_blanche() {
		//////////////////////////////////////////////////
		//		Face	 Orange			//
		//////////////////////////////////////////////////
		if (rubik.orange.coin1.couleur == Couleur.Blanc)
			{
				switch (rubik.orange.coin1.coinAdj2.couleur)
					{
						case Orange :	rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Vert);
								rubik.rotationHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Vert);
								face_blanche.coin1 = true;
								break;//check
										
						case Bleu   :	rubik.rotationHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Orange);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Orange);
								face_blanche.coin2 = true;
								break;//check
						
						case Vert   :	rubik.rotationAntiHoraire(Couleur.Rouge);
								rubik.rotationHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Rouge);
								face_blanche.coin4 = true;
								break;//check
										
						case Rouge  :	rubik.rotationAntiHoraire(Couleur.Bleu);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Bleu);
								face_blanche.coin3 = true;
								break;//check
					};
			}
		if (rubik.orange.coin2.couleur == Couleur.Blanc)
			{
				switch (rubik.orange.coin2.coinAdj1.couleur)
					{
						case Orange :	rubik.rotationHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Bleu);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Bleu);
								face_blanche.coin2 = true;
								break;//check
					
						case Bleu   :	rubik.rotationHoraire(Couleur.Rouge);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Rouge);
								face_blanche.coin3 = true;
								break;//check
									
						case Vert   :	rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Orange);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Orange);
								face_blanche.coin1 = true;
								break;//check
									
						case Rouge  :	rubik.rotationHoraire(Couleur.Vert);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Vert);
								face_blanche.coin4 = true;
								break;//check					
					};
			}
			
		if (rubik.orange.coin3.couleur == Couleur.Blanc)
			{
				rubik.rotationAntiHoraire(Couleur.Orange);
				rubik.rotationAntiHoraire(Couleur.Jaune);
				rubik.rotationHoraire(Couleur.Orange);
			}
		
		if (rubik.orange.coin4.couleur == Couleur.Blanc)
			{
				rubik.rotationHoraire(Couleur.Orange);
				rubik.rotationAntiHoraire(Couleur.Jaune);
				rubik.rotationAntiHoraire(Couleur.Orange);
			}

		//////////////////////////////////////////////////
		//		Face	 Vert			//
		//////////////////////////////////////////////////
		if (rubik.vert.coin1.couleur == Couleur.Blanc)
			{
				switch (rubik.vert.coin1.coinAdj1.couleur)
					{
						case  Orange :  rubik.rotationHoraire(Couleur.Bleu);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Bleu);
								face_blanche.coin2 = true;
								break;//check

						case  Bleu   :  rubik.rotationHoraire(Couleur.Rouge);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Rouge);
								face_blanche.coin3 = true;
								break;//check

						case  Vert   :  rubik.rotationHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Orange);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Orange);
								face_blanche.coin1 = true;
								break;//check
			
						case  Rouge  :  rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Vert);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Vert);
								face_blanche.coin4 = true;
								break;//check
					};
			}
		
		if (rubik.vert.coin2.couleur == Couleur.Blanc)
			{
				rubik.rotationAntiHoraire(Couleur.Vert);
				rubik.rotationAntiHoraire(Couleur.Jaune);
				rubik.rotationHoraire(Couleur.Vert);
			}

		if (rubik.vert.coin3.couleur == Couleur.Blanc)		
			{
				rubik.rotationHoraire(Couleur.Vert);
				rubik.rotationAntiHoraire(Couleur.Jaune);
				rubik.rotationAntiHoraire(Couleur.Vert);
			}
		
		if (rubik.vert.coin4.couleur == Couleur.Blanc)
			{
				switch (rubik.vert.coin4.coinAdj2.couleur)
					{
						case Orange :	rubik.rotationHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Vert);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Vert);
								face_blanche.coin1 = true;//check
								break;
		
						case Bleu   :   rubik.rotationAntiHoraire(Couleur.Orange);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Orange);
								face_blanche.coin2 = true;//check
								break;
					
						case Vert   :	rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Rouge);
								rubik.rotationHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Rouge);
								face_blanche.coin4 = true;//check
								break;
	
						case Rouge  :  	rubik.rotationAntiHoraire(Couleur.Bleu);
								rubik.rotationHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Bleu);
								face_blanche.coin3 = true;//check
								break;
					};
			}
		
		

		//////////////////////////////////////////////////
		//		Face	 Bleu			//
		//////////////////////////////////////////////////
		if (rubik.bleu.coin1.couleur == Couleur.Blanc)
			{
				rubik.rotationHoraire(Couleur.Bleu);
				rubik.rotationAntiHoraire(Couleur.Jaune);
				rubik.rotationAntiHoraire(Couleur.Bleu);
			}

		if (rubik.bleu.coin2.couleur == Couleur.Blanc )
			{
				switch (rubik.bleu.coin2.coinAdj2.couleur)
					{
						case Orange :	rubik.rotationAntiHoraire(Couleur.Vert);
								rubik.rotationHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Vert);
								face_blanche.coin1  = true;
								break;//check
	
						case Bleu   :	rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Orange);
								rubik.rotationHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Orange);
								face_blanche.coin2 = true;
								break;//check

						case Vert   :	rubik.rotationAntiHoraire(Couleur.Rouge);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Rouge);
								face_blanche.coin4 = true;
								break;//check
	
						case Rouge  :	rubik.rotationHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Bleu);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Bleu);
								face_blanche.coin3 = true;
								break;//check
					};
			}
		
		if (rubik.bleu.coin3.couleur == Couleur.Blanc )
			{
				switch (rubik.bleu.coin3.coinAdj1.couleur)
					{
						case Orange :	rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Bleu);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Bleu);
								face_blanche.coin2 = true;
								break;//check
				
						case Bleu   :	rubik.rotationHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Rouge);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Rouge);
								face_blanche.coin3 = true;
								break;//check

						case Vert   :	rubik.rotationHoraire(Couleur.Orange);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Orange);
								face_blanche.coin1 = true;
								break;//check
	
						case Rouge  :	rubik.rotationHoraire(Couleur.Vert);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Vert);
								face_blanche.coin4 = true;
								break;//check
					};
			}



		if (rubik.bleu.coin4.couleur == Couleur.Blanc)
			{
				rubik.rotationAntiHoraire(Couleur.Bleu);
				rubik.rotationAntiHoraire(Couleur.Jaune);
				rubik.rotationHoraire(Couleur.Bleu);	
			}


		//////////////////////////////////////////////////
		//		Face	 Rouge			//
		//////////////////////////////////////////////////
		
		if (rubik.rouge.coin1.couleur == Couleur.Blanc)
			{
				rubik.rotationAntiHoraire(Couleur.Rouge);
				rubik.rotationAntiHoraire(Couleur.Jaune);
				rubik.rotationHoraire(Couleur.Rouge);
			}
		
		if (rubik.rouge.coin2.couleur == Couleur.Blanc)
			{
				rubik.rotationHoraire(Couleur.Rouge);
				rubik.rotationAntiHoraire(Couleur.Jaune);
				rubik.rotationAntiHoraire(Couleur.Rouge);
			}

		if (rubik.rouge.coin3.couleur == Couleur.Blanc)
			{
				switch (rubik.rouge.coin3.coinAdj2.couleur)
					{
						case Orange :   rubik.rotationAntiHoraire(Couleur.Vert);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Vert);
								face_blanche.coin1 = true;
								break;//check
		
						case Bleu   :  	rubik.rotationAntiHoraire(Couleur.Orange);
								rubik.rotationHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Orange);
								face_blanche.coin2 = true;
								break;//check

						case Vert   :   rubik.rotationHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Rouge);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Rouge);
								face_blanche.coin4 = true;
								break;//check
				
						case Rouge  :   rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Bleu);
								rubik.rotationHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Bleu);
								face_blanche.coin3 = true;
								break;//check			
					};
			}

		if (rubik.rouge.coin4.couleur == Couleur.Blanc)
			{
				switch (rubik.rouge.coin4.coinAdj1.couleur)
					{
						case Orange :	rubik.rotationHoraire(Couleur.Bleu);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Bleu);
								face_blanche.coin2 = true;
								break;//check

						case Bleu   :   rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Rouge);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Rouge);
								face_blanche.coin3 = true;
								break;//check

						case Vert   : 	rubik.rotationHoraire(Couleur.Orange);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Orange);
								face_blanche.coin1 = true;
								break;//check
	
						case Rouge : 	rubik.rotationHoraire(Couleur.Jaune);
								rubik.rotationHoraire(Couleur.Vert);
								rubik.rotationAntiHoraire(Couleur.Jaune);
								rubik.rotationAntiHoraire(Couleur.Vert);
								face_blanche.coin4 = true;
								break;
					};

		
			}


		//////////////////////////////////////////////////
		//		Face	 Jaune			//
		//////////////////////////////////////////////////

		boolean bool = false;
		
		if (rubik.jaune.coin3.couleur == Couleur.Blanc)
			{
				if (rubik.jaune.coin3.coinAdj1.couleur == Couleur.Orange)
					{
						rubik.rotationHoraire(Couleur.Vert);
						rubik.rotationAntiHoraire(Couleur.Jaune);
						rubik.rotationAntiHoraire(Couleur.Vert);
						
					}
				else
					{
						rubik.rotationAntiHoraire(Couleur.Jaune);
						bool = true;
					}
			}
			
		if (rubik.jaune.coin4.couleur == Couleur.Blanc)
			{
				if (rubik.jaune.coin4.coinAdj1.couleur == Couleur.Vert)
					{
						rubik.rotationHoraire(Couleur.Rouge);
						rubik.rotationAntiHoraire(Couleur.Jaune);
						rubik.rotationAntiHoraire(Couleur.Rouge);
						
					}
				else
					{
						if (!bool)
							{
								rubik.rotationAntiHoraire(Couleur.Jaune);
								bool = true;
							}
					}
			}
			
		if (rubik.jaune.coin1.couleur == Couleur.Blanc)
			{
				if (rubik.jaune.coin1.coinAdj1.couleur == Couleur.Rouge)
					{
						rubik.rotationHoraire(Couleur.Bleu);
						rubik.rotationAntiHoraire(Couleur.Jaune);
						rubik.rotationAntiHoraire(Couleur.Bleu);
						
					}
				else
					{
						if (!bool)
							{
								rubik.rotationAntiHoraire(Couleur.Jaune);
								bool = true;
							}
					}
			}
			
		if (rubik.jaune.coin2.couleur == Couleur.Blanc)
			{
				if (rubik.jaune.coin2.coinAdj1.couleur == Couleur.Bleu)
					{
						rubik.rotationHoraire(Couleur.Orange);
						rubik.rotationAntiHoraire(Couleur.Jaune);
						rubik.rotationAntiHoraire(Couleur.Orange);
						
					}
				else
					{
						if (!bool)
							{
								rubik.rotationAntiHoraire(Couleur.Jaune);
								bool = true;
							}
					}
			}
		
	


		//////////////////////////////////////////////////
		//		Face	 Blanche		//
		//////////////////////////////////////////////////	

		if ( rubik.blanc.coin1.couleur == Couleur.Blanc && rubik.blanc.coin1.coinAdj1.couleur == Couleur.Vert)
			{
				face_blanche.coin1 = true;
			}
		else
			{	
				if ( rubik.blanc.coin1.couleur == Couleur.Blanc)	
					{
						rubik.rotationHoraire(Couleur.Orange);
						rubik.rotationHoraire(Couleur.Jaune);
						rubik.rotationAntiHoraire(Couleur.Orange);
					}
				face_blanche.coin1 = false;
			}
			
		if (rubik.blanc.coin2.couleur == Couleur.Blanc && rubik.blanc.coin2.coinAdj1.couleur == Couleur.Orange)
			{
				face_blanche.coin2 = true;
			}
		else
			{
				if ( rubik.blanc.coin2.couleur == Couleur.Blanc)	
					{
						rubik.rotationHoraire(Couleur.Bleu);
						rubik.rotationHoraire(Couleur.Jaune);
						rubik.rotationAntiHoraire(Couleur.Bleu);
					}
				face_blanche.coin2 = false;
			}
			
		if (rubik.blanc.coin3.couleur == Couleur.Blanc && rubik.blanc.coin3.coinAdj1.couleur == Couleur.Bleu)
			{
				face_blanche.coin3 = true;
			}
		else
			{
				if ( rubik.blanc.coin3.couleur == Couleur.Blanc)	
					{
						rubik.rotationHoraire(Couleur.Rouge);
						rubik.rotationHoraire(Couleur.Jaune);
						rubik.rotationAntiHoraire(Couleur.Rouge);
					}
				face_blanche.coin3 = false;
			}
			
		if (rubik.blanc.coin4.couleur == Couleur.Blanc && rubik.blanc.coin4.coinAdj1.couleur == Couleur.Rouge)
			{
				face_blanche.coin4 = true;
			}
		else
			{
				if ( rubik.blanc.coin4.couleur == Couleur.Blanc)	
					{
						rubik.rotationHoraire(Couleur.Vert);
						rubik.rotationHoraire(Couleur.Jaune);
						rubik.rotationAntiHoraire(Couleur.Vert);
					}
				face_blanche.coin4 = false;
			}
	}

	
	
	public void couronneSolve(Couleur couleur1,Couleur couleur2,Couleur couleur3) {
			Arrete ar = new Arrete(couleur1);
			switch (couleur1)
				{
					case Orange : ar = rubik.orange.arrete1; break;
					case Bleu : ar = rubik.bleu.arrete2; break;
					case Rouge : ar = rubik.rouge.arrete3; break;
					case Vert : ar = rubik.vert.arrete4; break;
				}
				
			if (ar.couleur == couleur1)
				{
					if (ar.arreteAdj.couleur == couleur2)
						{
							rubik.rotationHoraire(Couleur.Jaune);
							rubik.rotationHoraire(couleur2);
							rubik.rotationAntiHoraire(Couleur.Jaune);
							rubik.rotationAntiHoraire(couleur2);
							rubik.rotationAntiHoraire(Couleur.Jaune);
							rubik.rotationAntiHoraire(couleur1);
							rubik.rotationHoraire(Couleur.Jaune);
							rubik.rotationHoraire(couleur1);
						}
					if (ar.arreteAdj.couleur == couleur3)
						{
							rubik.rotationAntiHoraire(Couleur.Jaune);
							rubik.rotationAntiHoraire(couleur3);
							rubik.rotationHoraire(Couleur.Jaune);
							rubik.rotationHoraire(couleur3);
							rubik.rotationHoraire(Couleur.Jaune);
							rubik.rotationHoraire(couleur1);
							rubik.rotationAntiHoraire(Couleur.Jaune);
							rubik.rotationAntiHoraire(couleur1);
						}
				}
		}
	
	public void  couronne(){
	int i =0;
	while (!couronne.terminer())
		{
			couronneSolve(Couleur.Orange,Couleur.Bleu, Couleur.Vert);
			couronneSolve(Couleur.Bleu,Couleur.Rouge, Couleur.Orange);
			couronneSolve(Couleur.Rouge,Couleur.Vert, Couleur.Bleu);
			couronneSolve(Couleur.Vert,Couleur.Orange, Couleur.Rouge);
			
			rubik.rotationHoraire(Couleur.Jaune);
			
			couronne.checkCouronne(rubik);
			
			if (i == 3 &&couronne.canFinish(rubik)) 
				{
					couronne.finish(rubik);
					i=0;
				}
			
				
			couronne.checkCouronne(rubik);
			i++; i = i % 4;
		}
		
	}
	
	
	
	public void verif_Croix_Blanche(String m) {
			if (	(rubik.blanc.arrete1.couleur == Couleur.Blanc) &&
				(rubik.blanc.arrete2.couleur == Couleur.Blanc) &&
				(rubik.blanc.arrete3.couleur == Couleur.Blanc) &&
				(rubik.blanc.arrete4.couleur == Couleur.Blanc) )
				{	if(	(rubik.blanc.arrete1.arreteAdj.couleur == Couleur.Orange) &&
					(rubik.blanc.arrete2.arreteAdj.couleur == Couleur.Bleu) &&
					(rubik.blanc.arrete3.arreteAdj.couleur == Couleur.Rouge) &&
					(rubik.blanc.arrete4.arreteAdj.couleur == Couleur.Vert) )
						{System.out.println("Croix Blanche Terminee ("+m+")");}
					else
						{System.out.println("Croix Blanche Fail (Bord) ("+m+")");rubik.afficherTERM();}
				}
			else
				{System.out.println("Croix Blanche Fail (Croix) ("+m+")");rubik.afficherTERM();}
		}
		
	public void verif_Face_Blanche(String m) {
					if (	(rubik.blanc.coin1.couleur == Couleur.Blanc) && (rubik.blanc.coin1.coinAdj1.couleur == Couleur.Vert) &&
						(rubik.blanc.coin2.couleur == Couleur.Blanc) && (rubik.blanc.coin2.coinAdj1.couleur == Couleur.Orange) &&
						(rubik.blanc.coin3.couleur == Couleur.Blanc) && (rubik.blanc.coin3.coinAdj1.couleur == Couleur.Bleu) &&
						(rubik.blanc.coin4.couleur == Couleur.Blanc) && (rubik.blanc.coin4.coinAdj1.couleur == Couleur.Rouge) )
						{System.out.println("Face Blanche Terminee ("+m+")");}
					else
						
						{
							if (	(rubik.blanc.coin1.couleur == Couleur.Blanc) && 
								(rubik.blanc.coin2.couleur == Couleur.Blanc) && 
								(rubik.blanc.coin3.couleur == Couleur.Blanc) && 
								(rubik.blanc.coin4.couleur == Couleur.Blanc) )
								{
									System.out.println("1er Couronne Fail ("+m+")");	rubik.afficherTERM();	
								}
							else
						
								{
									System.out.println("Face Blanche Fail ("+m+")"); 	rubik.afficherTERM();
								}
						}
		}
		
		
	public ArrayList<String> solve() {
		
		//rubik.afficherTERM();

		while (!croix_blanche.terminer())
			{
				croix_blanche();
			}
		//verif_Croix_Blanche("");


		while (!face_blanche.terminer())
			{
				face_blanche();
			}
		//verif_Croix_Blanche("Corrompue");
		//verif_Face_Blanche("");

		couronne();
		//verif_Croix_Blanche("Corrompue");
		//verif_Face_Blanche("Corrompue");
		//couronne.testCouronne(rubik,"");
		
		croix_jaune.solve(rubik);
		//verif_Croix_Blanche("Corrompue");
		//verif_Face_Blanche("Corrompue");
		//couronne.testCouronne(rubik,"Corrompue");
		//croix_jaune.test(rubik,"");
		
		orientation.solve(rubik);
		//verif_Croix_Blanche("Corrompue");
		//verif_Face_Blanche("Corrompue");
		//couronne.testCouronne(rubik,"Corrompue");
		//croix_jaune.test(rubik,"Corrompue");
		//orientation.test(rubik,"");
		
		place_Coin.solve(rubik);
		//verif_Croix_Blanche("Corrompue");
		//verif_Face_Blanche("Corrompue");
		//couronne.testCouronne(rubik,"Corrompue");
		//croix_jaune.test(rubik,"Corrompue");
		//orientation.test(rubik,"Corrompue");
		//place_Coin.test(rubik,"");
		//System.out.println("");

	

		finale.solve(rubik);
		//verif_Croix_Blanche("Corrompue");
		//verif_Face_Blanche("Corrompue");
		//couronne.testCouronne(rubik,"Corrompue");
		//croix_jaune.test(rubik,"Corrompue");
		//orientation.test(rubik,"Corrompue");
		//place_Coin.test(rubik,"Corrompue");
		//finale.test(rubik,"");
		//System.out.println("");
		
		//rubik.afficherTERM();
		
		
		return rubik.list;
		}



	}
