public class Place_Coin {


	public boolean coin1(Rubik rubik) {
		return ((rubik.jaune.coin1.couleur == Couleur.Jaune && rubik.jaune.coin1.coinAdj1.couleur == Couleur.Bleu && rubik.jaune.coin1.coinAdj2.couleur == Couleur.Orange) ||
		(rubik.jaune.coin1.couleur == Couleur.Orange && rubik.jaune.coin1.coinAdj1.couleur == Couleur.Jaune && rubik.jaune.coin1.coinAdj2.couleur == Couleur.Bleu) ||
		(rubik.jaune.coin1.couleur == Couleur.Bleu && rubik.jaune.coin1.coinAdj1.couleur == Couleur.Orange && rubik.jaune.coin1.coinAdj2.couleur == Couleur.Jaune));
	}
	
	public boolean coin2(Rubik rubik) {
		return ((rubik.jaune.coin2.couleur == Couleur.Jaune && rubik.jaune.coin2.coinAdj1.couleur == Couleur.Orange && rubik.jaune.coin2.coinAdj2.couleur == Couleur.Vert) ||
		(rubik.jaune.coin2.couleur == Couleur.Vert && rubik.jaune.coin2.coinAdj1.couleur == Couleur.Jaune && rubik.jaune.coin2.coinAdj2.couleur == Couleur.Orange) ||
		(rubik.jaune.coin2.couleur == Couleur.Orange && rubik.jaune.coin2.coinAdj1.couleur == Couleur.Vert && rubik.jaune.coin2.coinAdj2.couleur == Couleur.Jaune));
	}
	
	public boolean coin3(Rubik rubik) {
		return ((rubik.jaune.coin3.couleur == Couleur.Jaune && rubik.jaune.coin3.coinAdj1.couleur == Couleur.Vert && rubik.jaune.coin3.coinAdj2.couleur == Couleur.Rouge) ||
		(rubik.jaune.coin3.couleur == Couleur.Rouge && rubik.jaune.coin3.coinAdj1.couleur == Couleur.Jaune && rubik.jaune.coin3.coinAdj2.couleur == Couleur.Vert) ||
		(rubik.jaune.coin3.couleur == Couleur.Vert && rubik.jaune.coin3.coinAdj1.couleur == Couleur.Rouge && rubik.jaune.coin3.coinAdj2.couleur == Couleur.Jaune));
	}
	
	public boolean coin4(Rubik rubik) {
		return ((rubik.jaune.coin4.couleur == Couleur.Jaune && rubik.jaune.coin4.coinAdj1.couleur == Couleur.Rouge && rubik.jaune.coin4.coinAdj2.couleur == Couleur.Bleu) ||
		(rubik.jaune.coin4.couleur == Couleur.Bleu && rubik.jaune.coin4.coinAdj1.couleur == Couleur.Jaune && rubik.jaune.coin4.coinAdj2.couleur == Couleur.Rouge) ||
		(rubik.jaune.coin4.couleur == Couleur.Rouge && rubik.jaune.coin4.coinAdj1.couleur == Couleur.Bleu && rubik.jaune.coin4.coinAdj2.couleur == Couleur.Jaune));
	}
	
	public boolean terminer(Rubik rubik) {
		return (coin1(rubik) && coin2(rubik) && coin3(rubik) && coin4(rubik));
	}
	
	
	public void formule(Rubik rubik,Couleur couleur1,Couleur couleur2) {
		rubik.rotationAntiHoraire(couleur1);
		rubik.rotationHoraire(Couleur.Jaune);
		rubik.rotationHoraire(couleur2);
		rubik.rotationAntiHoraire(Couleur.Jaune);
		rubik.rotationHoraire(couleur1);
		rubik.rotationHoraire(Couleur.Jaune);
		rubik.rotationAntiHoraire(couleur2);
		rubik.rotationAntiHoraire(Couleur.Jaune);
	}
	
	public void solve(Rubik rubik) {
		while (!terminer(rubik))	
			{
				if (coin1(rubik))
					{
						formule(rubik,Couleur.Vert,Couleur.Bleu);
					}
				else
					{
						if (coin2(rubik))
							{
								formule(rubik,Couleur.Rouge,Couleur.Orange);
							}
						else
							{
								if (coin3(rubik))
									{
										formule(rubik,Couleur.Bleu,Couleur.Vert);
									}
								else
									{
										formule(rubik,Couleur.Orange,Couleur.Rouge);
									}
							}
					}
			}
	}
	
	
	public void test(Rubik rubik, String m) {
		if (terminer(rubik))
			{
				System.out.println("Place Coin Terminer (" + m+")");
			}
		else
			{
				System.out.println("Place Coin Fail (" + m+")");
			}
		}

}
