

//Java standart API
import java.awt.Frame;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.BorderLayout;
//Java3d API
import com.sun.j3d.utils.universe.SimpleUniverse;
import javax.media.j3d.Canvas3D;
import javax.media.j3d.BranchGroup;
import javax.media.j3d.TransformGroup;
import javax.media.j3d.Transform3D;
import javax.vecmath.Vector3f;
import javax.vecmath.Color3f;
//mes objets

import javax.media.j3d.BoundingSphere;
import javax.vecmath.Point3d;

import com.sun.j3d.utils.image.TextureLoader;
import javax.media.j3d.ImageComponent2D;
import javax.media.j3d.Background;
import javax.vecmath.Vector3d;


class cubes extends Frame implements WindowListener
{
	public Rubik rubik;
	
	
	cubes()
	{
		super("TIPE : Rubik's Cube");
        this.addWindowListener(this);
        setLayout(new BorderLayout());
        Canvas3D canvas = new Canvas3D(SimpleUniverse.getPreferredConfiguration());
        add("Center", canvas);
		
		rubik = new Rubik();
		//rubik.melange();
        
        SimpleUniverse simpleU = new SimpleUniverse(canvas);
        simpleU.getViewingPlatform().setNominalViewingTransform();
        
        BranchGroup scene = createSceneGraph();
        scene.compile();
        simpleU.addBranchGraph(scene);        
				

	}
	
	BranchGroup createSceneGraph()
	{
		//on crée le Bg principal
		BranchGroup objRoot=new BranchGroup();
			
			
        	TransformGroup TG=new TransformGroup();
			TG.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        	TG.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
			TG.setCapability(TransformGroup.ALLOW_CHILDREN_EXTEND);
			TG.setCapability(TransformGroup.ALLOW_CHILDREN_READ);
			TG.setCapability(TransformGroup.ALLOW_CHILDREN_WRITE);
			
			anim anm=new anim(TG,rubik);
			
		// On définit une zone d'influence 
			BoundingSphere influPartout=new BoundingSphere(new Point3d(),1000.0);
			anm.setSchedulingBounds(influPartout);
			
			
			TransformGroup tg=new TransformGroup();
			Transform3D rot=new Transform3D();
			Transform3D rotation=new Transform3D();
			rot.setIdentity();
			tg.getTransform(rotation);
			rot.setScale(new Vector3d(0.6d,0.6d,0.6d));
			rotation.mul(rot);
			TG.setTransform(rotation);
				
			
			objRoot.addChild(anm);
			objRoot.addChild(TG);
		
			TextureLoader myLoader = new TextureLoader( "Background3.png", this );
			ImageComponent2D myImage = myLoader.getImage( );
			
			Background myBack = new Background( );
			myBack.setImage( myImage );
			
			BoundingSphere myBounds = new BoundingSphere(
			new Point3d( ), 1000.0 );
			myBack.setApplicationBounds( myBounds );
			
			objRoot.addChild(myBack);
			
		return objRoot;
	}
		
	//fonctions de gestion des evenements window
	public void windowActivated(WindowEvent e){}
	public void windowClosed(WindowEvent e){}
	public void windowDeactivated(WindowEvent e){}
	public void windowDeiconified(WindowEvent e){}
	public void windowIconified(WindowEvent e){}
	public void windowOpened(WindowEvent e){}
	
	public void windowClosing(WindowEvent e)
	{
		System.exit(1);
	}
	
	public static void main(String args[])
	{
		cubes myApp=new cubes();
		myApp.setSize(810,724);
		myApp.setVisible(true);
	}
}

