import java.awt.Frame;
import com.sun.j3d.utils.image.TextureLoader;
import com.sun.j3d.utils.geometry.Cylinder;
import javax.media.j3d.BranchGroup;
import javax.media.j3d.BranchGroup;
import javax.media.j3d.Geometry;
import javax.media.j3d.TriangleStripArray;
import javax.media.j3d.Appearance;
import javax.media.j3d.Shape3D;
import javax.media.j3d.PolygonAttributes;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.media.j3d.ImageComponent2D;
import javax.media.j3d.Texture2D;
import javax.media.j3d.Texture;
import javax.media.j3d.TextureAttributes;
import javax.vecmath.Color3f;
import javax.vecmath.Point3f;
import javax.vecmath.Vector3f;
import javax.vecmath.Point2f;
import javax.vecmath.Color4f;
import javax.media.j3d.QuadArray;
import javax.media.j3d.RenderingAttributes;

class facette
{
	private Vector3f vect;
	private Color3f color;

	public facette(Vector3f vect,Color3f color)
	{
		this.vect=vect;
		this.color=color;
		
	}

	public BranchGroup createFace(String side)
	{
		BranchGroup myScene=new BranchGroup();
		//myScene.setCapability(ALLOW_COLOR_WRITE);
		Shape3D face=new Shape3D(quadFace(side));
		
		
						
		//les transformations
		TransformGroup trTot=mkTgTr(vect);
		
		trTot.addChild(face);
				
		myScene.addChild(trTot);
		//myScene.compile();
		return myScene;
	}
	
	private static TransformGroup mkTgTr(Vector3f vect)
	{
		Transform3D tr3d=new Transform3D();
		tr3d.setTranslation(vect);
		TransformGroup tg=new TransformGroup(tr3d);
		return tg;
	}
	
	private QuadArray quadFace(String side)
	{
		QuadArray quad =new QuadArray(4,QuadArray.COORDINATES|QuadArray.COLOR_3);
		switch (side)
			{
				case "R": 	quad.setCoordinate(0,new Point3f(0f,0.2f,-0.2f));
							quad.setCoordinate(1,new Point3f(0f,0.2f,0.2f));
							quad.setCoordinate(2,new Point3f(0f,-0.2f,0.2f));
							quad.setCoordinate(3,new Point3f(0f,-0.2f,-0.2f));
					break;
				case "F":	quad.setCoordinate(0,new Point3f(0.2f,-0.2f,0f));
							quad.setCoordinate(1,new Point3f(0.2f,0.2f,0f));
							quad.setCoordinate(2,new Point3f(-0.2f,0.2f,0f));
							quad.setCoordinate(3,new Point3f(-0.2f,-0.2f,0f));
					break;
				case "D":	quad.setCoordinate(0,new Point3f(0.2f,0f,-0.2f));
							quad.setCoordinate(1,new Point3f(0.2f,0f,0.2f));
							quad.setCoordinate(2,new Point3f(-0.2f,0f,0.2f));
							quad.setCoordinate(3,new Point3f(-0.2f,0f,-0.2f));
					break;
				case "L": 	quad.setCoordinate(0,new Point3f(0f,0.2f,-0.2f));
							quad.setCoordinate(3,new Point3f(0f,0.2f,0.2f));
							quad.setCoordinate(2,new Point3f(0f,-0.2f,0.2f));
							quad.setCoordinate(1,new Point3f(0f,-0.2f,-0.2f));
					break;
				case "B":	quad.setCoordinate(0,new Point3f(0.2f,-0.2f,0f));
							quad.setCoordinate(3,new Point3f(0.2f,0.2f,0f));
							quad.setCoordinate(2,new Point3f(-0.2f,0.2f,0f));
							quad.setCoordinate(1,new Point3f(-0.2f,-0.2f,0f));
					break;
				case "U":	quad.setCoordinate(0,new Point3f(0.2f,0f,-0.2f));
							quad.setCoordinate(3,new Point3f(0.2f,0f,0.2f));
							quad.setCoordinate(2,new Point3f(-0.2f,0f,0.2f));
							quad.setCoordinate(1,new Point3f(-0.2f,0f,-0.2f));
					break;
				
			}
		for (int i=0;i<4;i++) quad.setColor(i,color);

		
		return quad;
	}
	

}