import javax.vecmath.Color3f;

public class Face {
	public Coin coin1; 
	public Coin coin2;
	public Coin coin3;
	public Coin coin4;
	
	public Arrete arrete1;
	public Arrete arrete2;	
	public Arrete arrete3;
	public Arrete arrete4;
	
	public Couleur centre;
	
	public Color3f jaune;
	public Color3f blanc;
	public Color3f orange;
	public Color3f rouge;
	public Color3f vert;
	public Color3f bleu;
	
	 public Face clone(){  
		Face face = new Face(centre);
		face.coin1 = coin1.clone();
		face.coin2 = coin2.clone();
		face.coin3 = coin3.clone();
		face.coin4 = coin4.clone();
		
		face.arrete1 = arrete1.clone();
		face.arrete2 = arrete2.clone();
		face.arrete3 = arrete3.clone();
		face.arrete4 = arrete4.clone();
		
		face.centre	= centre;
		
		return face;
    }
	
	public Face(Couleur couleurFace) {
		coin1 = new Coin(couleurFace);
		coin2 = new Coin(couleurFace);
		coin3 = new Coin(couleurFace);
		coin4 = new Coin(couleurFace);

		arrete1 = new Arrete(couleurFace);
		arrete2 = new Arrete(couleurFace);
		arrete3 = new Arrete(couleurFace);
		arrete4 = new Arrete(couleurFace);	
		
		jaune = new Color3f(1f,1f,0f);
		blanc = new Color3f(1f,1f,1f);
		rouge = new Color3f(1f,0f,0f);
		orange = new Color3f(1f,0.5f,0f);
		vert = new Color3f(0f,1f,0f);
		bleu = new Color3f(0f,0f,1f);
		
		centre = couleurFace;
		}
		
	public Color3f color()
		{
			Color3f res = jaune;
			switch (centre)
				{
					case Orange : res = orange;
							break;
					case Blanc : res =blanc;
							break;
					case Bleu : res = bleu;
							break;
					case Vert : res = vert;
							break;
					case Rouge : res =rouge;
							break;
				};
			return res;
		}
		
		public void pipe() {
			System.out.print("|");
			}
			
		public void afficherCentre() {
		switch (centre)
				{
					case Orange : System.out.print("O ");
							break;
					case Blanc : System.out.print("Bc");
							break;
					case Bleu : System.out.print("Bl");
							break;
					case Vert : System.out.print("V ");
							break;
					case Rouge : System.out.print("R ");
							break;
					case Jaune : System.out.print("J ");
							break;
				};
			}
			
			
		public void afficherFace() {
			pipe();		coin1.afficher();	pipe();		arrete1.afficher();		pipe(); 	coin2.afficher();	pipe(); System.out.println("");
			pipe();		arrete4.afficher();	pipe();		afficherCentre();		pipe(); 	arrete2.afficher();	pipe(); System.out.println("");
			pipe();		coin4.afficher();	pipe();		arrete3.afficher();		pipe(); 	coin3.afficher();	pipe(); System.out.println("");
			}

  }

